// VPakDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "VPak.h"
#include "VPakDlg.h"
#include "FilterSelection.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl 'Info'

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	virtual BOOL OnInitDialog();

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	static TCHAR szFeatText[ 128 ];
	wsprintf( szFeatText, TEXT( "feat. VFS %x.%x" ),
			  VFS_HIBYTE( VFS_GetVersion() ),
			  VFS_LOBYTE( VFS_GetVersion() ) );
	GetDlgItem( IDC_FEATURING_TEXT )->SetWindowText( szFeatText );

	return TRUE;
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CVPakDlg Dialogfeld



CVPakDlg::CVPakDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVPakDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVPakDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CONTENT_LIST, m_ContentList);
}

BEGIN_MESSAGE_MAP(CVPakDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_NEW_ARCHIVE, OnNewArchive)
	ON_BN_CLICKED(IDC_OPEN_ARCHIVE, OnOpenArchive)
	ON_BN_CLICKED(IDC_EXTRACT_ARCHIVE, OnExtractArchive)
	ON_BN_CLICKED(IDC_SHOW_INFORMATION, OnShowInformation)
	ON_BN_CLICKED(IDC_SHOW_ABOUT, OnShowAbout)
END_MESSAGE_MAP()


// CVPakDlg Meldungshandler

BOOL CVPakDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	// Insert columns into the content list.
	m_ContentList.InsertColumn( 0, TEXT( "File Name" ), LVCFMT_LEFT, 170 );
	m_ContentList.InsertColumn( 1, TEXT( "Path" ), LVCFMT_LEFT, 355 );
	m_ContentList.InsertColumn( 2, TEXT( "Size" ), LVCFMT_RIGHT, 63 );

    // File-Dialoge erzeugen...
	CString strFilter;
	strFilter.Format( TEXT( "VFS Archives (*.%s)|*.%s||" ),
					  ( LPCTSTR )CString( VFS_ARCHIVE_FILE_EXTENSION ),
					  ( LPCTSTR )CString( VFS_ARCHIVE_FILE_EXTENSION ) );
	m_pFileOpen = std::auto_ptr< CFileDialog >(
		new CFileDialog( TRUE, VFS_String( VFS_ARCHIVE_FILE_EXTENSION ).c_str(), 0,
						 OFN_HIDEREADONLY, strFilter )
		);
	m_pFileSave = std::auto_ptr< CFileDialog >(
		new CFileDialog( FALSE, VFS_String( VFS_ARCHIVE_FILE_EXTENSION ).c_str(), 0,
						 OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, strFilter )
		);

	// TODO: Hier zustzliche Initialisierung einfgen
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CVPakDlg::UpdateContentList()
{
	try
	{
		// Change the Header.
		SetWindowText( ( TEXT( "VPak - (" ) + m_strArchiveFile + TEXT( "." ) + VFS_ARCHIVE_FILE_EXTENSION + TEXT( ")" ) ).c_str() );

		// Clear the Content List.
		m_ContentList.DeleteAllItems();

		// Check if we can open the File.
		if( !VFS_Archive_GetInfo( m_strArchiveFile, m_ArchiveInfo ) )
			throw 911; // *ggg*

		// Make a list of all contained Files.
		VFS_EntityInfoList EntityInfoList;
		if( !VFS_Dir_GetContents( m_strArchiveFile, EntityInfoList, VFS_TRUE ) )
			throw 911;
		INT nIndex = 0;
		m_nNumDirs = 0;
		m_nNumFiles = 0;
		m_nNumUncompressedBytes = 0;
		for( VFS_EntityInfoList::const_iterator iter = EntityInfoList.begin(); iter != EntityInfoList.end(); iter++ )
		{
			// Collect Stats.
			if( ( *iter ).eType == VFS_DIR )
				m_nNumDirs++;
			else if( ( *iter ).eType == VFS_FILE )
				m_nNumFiles++;
			m_nNumUncompressedBytes += ( *iter ).lSize;

            // Ignore non-files.
			if( ( *iter ).eType != VFS_FILE )
				continue;

            // Set the Name.
			int nRealIndex = m_ContentList.InsertItem( nIndex, ( *iter ).strName.c_str() );

			// Set the Path (without the File Name).
			VFS_String strPath = ( *iter ).strPath;
			VFS_Util_GetPath( strPath, strPath );

			// Remove the Archive File out of the Path.
			strPath = strPath.substr( m_strArchiveFile.size() );
			if( strPath != VFS_TEXT( "" ) ) // means it now looks like /....
				strPath = strPath.substr( 1 );

			m_ContentList.SetItemText( nRealIndex, 1, strPath.c_str() );

			// Set the Size.
			CString strNum;
			strNum.Format( TEXT( "%i" ), ( *iter ).lSize );

			m_ContentList.SetItemText( nRealIndex, 2, strNum );

			nIndex++;
		}

		// Enable the 2 Buttons.
		GetDlgItem( IDC_EXTRACT_ARCHIVE )->EnableWindow();
		GetDlgItem( IDC_SHOW_INFORMATION )->EnableWindow();

		// Enable the Content List.
		m_ContentList.EnableWindow();
	}
	catch( ... )
	{
		theApp.ReportError();

		// Change the Header.
		m_strArchiveFile = TEXT( "" );
		SetWindowText( TEXT( "VPak - (no open archive)" ) );

		// Disable the 2 Buttons.
		GetDlgItem( IDC_EXTRACT_ARCHIVE )->EnableWindow( FALSE );
		GetDlgItem( IDC_SHOW_INFORMATION )->EnableWindow( FALSE );

		// Disable the Content List.
		m_ContentList.EnableWindow( FALSE );
	}
}

void CVPakDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CVPakDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CVPakDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CVPakDlg::OnNewArchive()
{
    // Get the Shell Memory Allocator.
	LPMALLOC pMalloc;
	HRESULT hResult = SHGetMalloc( &pMalloc );
	ASSERT( hResult == NOERROR );

    // --- Source ---
    // Browse for a Folder.
    TCHAR szPath[ MAX_PATH ];
	BROWSEINFO BI;
	BI.hwndOwner = *this;
	BI.pidlRoot = NULL;
	BI.pszDisplayName = szPath;
	BI.lpszTitle = TEXT( "Select Source Directory..." );
	BI.ulFlags = BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE;
	BI.lpfn = NULL;
	BI.lParam = 0;
	BI.iImage = 0;
	ITEMIDLIST* pIDList = SHBrowseForFolder( &BI );
	if( pIDList == NULL )
		return;

	// Get the Path.
	BOOL bSucceeded = SHGetPathFromIDList( pIDList, szPath );
	if( !bSucceeded )
	{
		MessageBox( TEXT( "Couldn't get Information about the selected Folder. Please select a valid Folder." ),
					TEXT( "Error" ), MB_OK | MB_ICONERROR );

		// Free the ID List & the Allocator.
		pMalloc->Free( pIDList );
		pMalloc->Release();
		return;
	}

	// Free the ID List & the Allocator.
	pMalloc->Free( pIDList );
	pMalloc->Release();

	// Convert the Path Name.
	VFS_String strSource( szPath );
	std::replace( strSource.begin(), strSource.end(), VFS_TEXT( '\\' ), VFS_TEXT( '/' ) );

    // --- Target ---
	if( m_pFileSave->DoModal() != IDOK )
		return;

	// Convert the Path Name.
	VFS_String strTarget = m_pFileSave->GetPathName();
	strTarget = strTarget.substr( 0, strTarget.size() - 1 - VFS_String( VFS_ARCHIVE_FILE_EXTENSION ).size() );
	std::replace( strTarget.begin(), strTarget.end(), VFS_TEXT( '\\' ), VFS_TEXT( '/' ) );

	// --- Filters ---
	CFilterSelection Sel( this );
	if( Sel.DoModal() != IDOK )
		return;

	// --- Create ---
	if( !VFS_Archive_CreateFromDirectory( strTarget, strSource, m_FilterNames, VFS_TRUE ) )
	{
		theApp.ReportError();
		return;
	}

    // --- Update ---
	m_strArchiveFile = strTarget;
	UpdateContentList();

	// Show it.
	MessageBox( TEXT( "Created the Archive \"" )+ CString( strTarget.c_str() ) + TEXT( "\"." ),
				TEXT( "Success" ), MB_OK | MB_ICONINFORMATION );
}

void CVPakDlg::OnOpenArchive()
{
	if( m_pFileOpen->DoModal() == IDOK )
	{
		m_strArchiveFile = m_pFileOpen->GetPathName();
		m_strArchiveFile = m_strArchiveFile.substr( 0, m_strArchiveFile.size() - 1 -
													VFS_String( VFS_ARCHIVE_FILE_EXTENSION ).size() );
		std::replace( m_strArchiveFile.begin(), m_strArchiveFile.end(), VFS_TEXT( '\\' ), VFS_TEXT( '/' ) );
		UpdateContentList();
	}
}

void CVPakDlg::OnExtractArchive()
{
	// Should not happen...
	if( m_strArchiveFile.size() == 0 )
		return;

    // Get the Shell Memory Allocator.
	LPMALLOC pMalloc;
	HRESULT hResult = SHGetMalloc( &pMalloc );
	ASSERT( hResult == NOERROR );

    // Browse for a Folder.
    TCHAR szPath[ MAX_PATH ];
	BROWSEINFO BI;
	BI.hwndOwner = *this;
	BI.pidlRoot = NULL;
	BI.pszDisplayName = szPath;
	BI.lpszTitle = TEXT( "Select Target Directory..." );
	BI.ulFlags = BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE;
	BI.lpfn = NULL;
	BI.lParam = 0;
	BI.iImage = 0;
	ITEMIDLIST* pIDList = SHBrowseForFolder( &BI );
	if( pIDList == NULL )
		return;

	// Get the Path.
	BOOL bSucceeded = SHGetPathFromIDList( pIDList, szPath );
	if( !bSucceeded )
	{
		MessageBox( TEXT( "Couldn't extract to the selected Folder. Please select a valid Folder." ),
					TEXT( "Error" ), MB_OK | MB_ICONERROR );

		// Free the ID List & the Allocator.
		pMalloc->Free( pIDList );
		pMalloc->Release();
		return;
	}

	// Try to extract into that Directory.
	VFS_String strPath( szPath );
	std::replace( strPath.begin(), strPath.end(), VFS_TEXT( '\\' ), VFS_TEXT( '/' ) );
	if( !VFS_Archive_Extract( m_strArchiveFile, VFS_String( strPath ) ) )
		theApp.ReportError();
	else
		MessageBox( ( TEXT( "\"" ) + m_strArchiveFile + TEXT( "\" has been successfully extracted into \"" ) +
        			strPath + TEXT( "\"." ) ).c_str(), TEXT( "Success" ), MB_OK | MB_ICONINFORMATION );

    // Free the ID List & the Allocator.
	pMalloc->Free( pIDList );
	pMalloc->Release();
}

void CVPakDlg::OnShowInformation()
{
	// Should not happen...
	if( m_strArchiveFile.size() == 0 )
		return;

	/*
		File:\t....
		Path:\t....
		Compressed Size:\t....
		Uncompressed Size:\t....
		Files:\t...
		Dirs:\t....

		Applied Filters:
		....
	*/

	// Format the Filter Name List.
	VFS_String strFilters;
	VFS_FilterNameList FilterNames;
	if( !VFS_Archive_GetUsedFilters( m_strArchiveFile, FilterNames ) )
	{
		theApp.ReportError();
		return;
	}
	for( VFS_FilterNameList::const_iterator iter = FilterNames.begin(); iter != FilterNames.end(); iter++ )
	{
		strFilters += ( *iter ) + TEXT( "\n" );
	}
	if( FilterNames.size() == 0 )
		strFilters = TEXT( "(none)" );

	// Format the Message.
	CString strMessage;
	strMessage.Format( TEXT( "File:\t\t\t%s\nPath:\t\t\t%s\nCompressed Size:\t\t%i bytes\nUncompressed Size:\t%i bytes\nDirs:\t\t\t%i\nFiles:\t\t\t%i\n\nApplied Filters:\n%s" ),
		m_ArchiveInfo.strName.c_str(), m_ArchiveInfo.strPath.c_str(), m_ArchiveInfo.lSize,
		m_nNumUncompressedBytes, m_nNumDirs, m_nNumFiles, strFilters.c_str() );

	// Show a Message Box.
	MessageBox( strMessage, TEXT( "Archive Information..." ), MB_OK | MB_ICONINFORMATION );
}

void CVPakDlg::OnShowAbout()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}
