// UNOPTIMIZED!!!!!!!!!!!
#pragma once
#include "stdafx.h"
#include "ZipFilter.h"
#include "zlib/zlib.h"

CZipFilter g_ZipFilter;

// Allocator.
struct ALLOC
{
	ALLOC( VFS_DWORD dwSize )
	{ this->dwSize = dwSize; this->pMeg = new VFS_BYTE[ dwSize ]; }
	~ALLOC()
	{ delete[] pMeg; }

    VFS_DWORD dwSize;
	VFS_BYTE* pMeg;
};

// Encoding / Decoding Procedures.
VFS_BOOL CZipFilter::Encode( VFS_FilterReadProc Reader, VFS_FilterWriteProc Writer, const VFS_EntityInfo& DecodedInfo ) const
{
	static ALLOC A( 10 * 1024 ), B( 11 * 1024 );

    // 10k Chunks...
    VFS_DWORD dwRead = 0;
	while( Reader( A.pMeg, A.dwSize, &dwRead ) )
	{
		// Save the Chunk Size.
		Writer( ( const VFS_BYTE* )&dwRead, sizeof( VFS_DWORD ) );

		// Compress.
		VFS_DWORD dwOutSize = B.dwSize;
		::compress( B.pMeg, &dwOutSize, A.pMeg, A.dwSize );

		// Save the Out Size.
		Writer( ( const VFS_BYTE* )&dwOutSize, sizeof( VFS_DWORD ) );

		// Write all Bytes.
		Writer( B.pMeg, dwOutSize );
	}

	return VFS_TRUE;
}

VFS_BOOL CZipFilter::Decode( VFS_FilterReadProc Reader, VFS_FilterWriteProc Writer, const VFS_EntityInfo& EncodedInfo ) const
{
	static ALLOC A( 11 * 1024 ), B( 10 * 1024 );

    // 10k Chunks...
    VFS_DWORD dwToRead = 0;
	while( Reader( ( VFS_BYTE* )&dwToRead, sizeof( VFS_DWORD ) ) )
	{
		// Create a new Alloc if necessary.
		if( dwToRead > B.dwSize )
			B = ALLOC( dwToRead );

		// Read in the Out Size.
		VFS_DWORD dwOutSize;
		Reader( ( VFS_BYTE* )&dwOutSize, sizeof( VFS_DWORD ) );

		// Read in the old data.
		Reader( A.pMeg, dwOutSize );

		// Uncompress.
		::uncompress( B.pMeg, &dwToRead, A.pMeg, dwOutSize );

		// Write all Bytes.
		Writer( B.pMeg, dwToRead );
	}

	return VFS_TRUE;
}

// Filter Configuration Data Management.
VFS_BOOL CZipFilter::LoadConfigData( VFS_FilterReadProc Reader )
{ return VFS_TRUE; }

VFS_BOOL CZipFilter::SaveConfigData( VFS_FilterWriteProc Writer ) const
{ return VFS_TRUE; }

VFS_DWORD CZipFilter::GetConfigDataSize() const
{ return 0; }